import * as i0 from '@angular/core';
import { Directive, Input, NgModule } from '@angular/core';

/** ------------------------------------------------------------------------------- */
/**
 * provide search text highlight
 * @author Sankar Sahu
 */
class HighlightDirective {
    /** provide content */
    set content(content) {
        this._content = content;
    }
    get content() { return this._content; }
    ;
    /** provide search term */
    set searchTerm(searchTerm) {
        this._searchTerm = searchTerm;
        this.highlight();
    }
    get searchTerm() { return this._searchTerm; }
    ;
    constructor(el) {
        this.el = el;
        /** provide content */
        this._content = '';
        /** provide search Term */
        this._searchTerm = '';
        /** provide separated text */
        this.separatedText = [];
        /** provide separated search text */
        this.separatedSearchedText = [];
        /** provide final text */
        this.final = '';
        /** provide split flag */
        this.splitFlag = '';
        /** provide match flag */
        this.matchFlag = '';
        /** provide span start */
        this.spanStart = '<span class="ngx-text-highlight">';
        /** provide span end */
        this.spanEnd = '</span>';
        this.caseSensitive = false;
    }
    /**
     * provide highlight text
     * @author Sankar Sahu
     */
    highlight() {
        this.final = '';
        if (!this.caseSensitive) {
            this.splitFlag = 'i';
            this.matchFlag = 'gi';
        }
        else {
            this.splitFlag = '';
            this.matchFlag = 'g';
        }
        this._searchTerm = (this._searchTerm) ? this.escapeRegExp(this._searchTerm) : this._searchTerm;
        this.searchPattern = new RegExp(this._searchTerm, this.splitFlag);
        this.matchPattern = new RegExp(this._searchTerm, this.matchFlag);
        if (this._searchTerm !== undefined && this._searchTerm != null && this._searchTerm.length > 0) {
            this.separatedText = this._content.split(this.searchPattern);
            this.separatedSearchedText = this._content.match(this.matchPattern);
            if (this.separatedSearchedText != null && this.separatedSearchedText.length > 0) {
                for (let i = 0; i < this.separatedText.length; i++) {
                    if (i <= this.separatedSearchedText.length - 1) {
                        this.final += this.separatedText[i] + this.spanStart + this.separatedSearchedText[i] + this.spanEnd;
                    }
                    else {
                        this.final += this.separatedText[i];
                    }
                }
            }
            if (this.final.length > 0) {
                this.el.nativeElement.innerHTML = this.final;
            }
            else {
                this.el.nativeElement.innerText = this._content;
            }
        }
        else {
            this.el.nativeElement.innerText = this._content;
        }
    }
    /**
     * provide replace spacial character on string
     * @author Sankar Sahu
     * @param searchTerm :provide search string
     */
    escapeRegExp(searchTerm) {
        return searchTerm.replace(/[.*+?^${}()|[\]\\]/g, '\\$&'); // $& means the whole matched string
    }
}
HighlightDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: HighlightDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
HighlightDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.2.10", type: HighlightDirective, selector: "[ngTextWordHighlight]", inputs: { caseSensitive: "caseSensitive", content: "content", searchTerm: "searchTerm" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: HighlightDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngTextWordHighlight]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { caseSensitive: [{
                type: Input
            }], content: [{
                type: Input,
                args: ['content']
            }], searchTerm: [{
                type: Input,
                args: ['searchTerm']
            }] } });

class NgTextWordHighlightModule {
}
NgTextWordHighlightModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: NgTextWordHighlightModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgTextWordHighlightModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.2.10", ngImport: i0, type: NgTextWordHighlightModule, declarations: [HighlightDirective], exports: [HighlightDirective] });
NgTextWordHighlightModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: NgTextWordHighlightModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.10", ngImport: i0, type: NgTextWordHighlightModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        HighlightDirective
                    ],
                    imports: [],
                    exports: [
                        HighlightDirective
                    ]
                }]
        }] });

/*
 * Public API Surface of ng-text-word-highlight
 */

/**
 * Generated bundle index. Do not edit.
 */

export { HighlightDirective, NgTextWordHighlightModule };
//# sourceMappingURL=ng-text-word-highlight.mjs.map
