import { ElementRef } from '@angular/core';
import * as i0 from "@angular/core";
/** ------------------------------------------------------------------------------- */
/**
 * provide search text highlight
 * @author Sankar Sahu
 */
export declare class HighlightDirective {
    private el;
    /** provide content */
    private _content;
    /** provide search Term */
    private _searchTerm;
    /** provide separated text */
    private separatedText;
    /** provide separated search text */
    private separatedSearchedText;
    /** provide final text */
    private final;
    /** provide search pattern */
    searchPattern: any;
    /** provide match pattern */
    matchPattern: any;
    /** provide split flag */
    splitFlag: string;
    /** provide match flag */
    matchFlag: string;
    /** provide span start */
    spanStart: string;
    /** provide span end */
    spanEnd: string;
    /** provide to case sensitive */
    caseSensitive: boolean;
    /** provide content */
    set content(content: string);
    get content(): string;
    /** provide search term */
    set searchTerm(searchTerm: string);
    get searchTerm(): string;
    constructor(el: ElementRef);
    /**
     * provide highlight text
     * @author Sankar Sahu
     */
    highlight(): void;
    /**
     * provide replace spacial character on string
     * @author Sankar Sahu
     * @param searchTerm :provide search string
     */
    private escapeRegExp;
    static ɵfac: i0.ɵɵFactoryDeclaration<HighlightDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<HighlightDirective, "[ngTextWordHighlight]", never, { "caseSensitive": "caseSensitive"; "content": "content"; "searchTerm": "searchTerm"; }, {}, never, never, false, never>;
}
